#!/usr/bin/env ruby

# Parse options.
require 'optparse'

help_message =<<HELP
Usage:
  #{File.basename(__FILE__)} [-i interval] [-s start] args [...]
  some_cmd | #{File.basename(__FILE__)}  [-i interval] [-s start] '-'

HELP

interval = 2
ind = 0

begin
  OptionParser.new(help_message) do |opt|
    opt.on('-i num', '--interval num', Integer, "Set the interval of arguments.") do |v|
      interval = v
    end
    opt.on('-s num', '--start num', Integer, 'Set the start index.') do |v|
      ind = v
    end
    opt.parse!(ARGV)
  end
rescue OptionParser::InvalidOption
  $stderr.print <<MES
error: Invalid Option
#{help_message}
MES
  exit(2)
rescue OptionParser::InvalidArgument
  $stderr.print <<MES
error: Invalid Argument
#{help_message}
MES
  exit(2)
end

if ARGV.size == 0 || ARGV[0] == '-'
  i = 0
  while arg = gets
    ind += interval if ind < i
    puts arg if ind == i
    i += 1
  end
else
  ARGV.each_with_index do |arg, i|
    ind += interval if ind < i
    puts arg if ind == i
  end
end
